#include<reg51.h>
#include<string.h>
#include<ctype.h>
#define bufferSize 100 //+CMGR: "REC READ","+85291234567",                        
#define bufferend bufferSize-2 //,"07/02/18,00:12:05+32"Hello"

					
sbit rs = P3^5;
sbit e = P3^4;
sbit ldr = P2^0;
sbit um = P2^1;
sbit tm = P2^2;
sbit badnumber = P2^3; //warning led  for testing

unsigned char receivingMessage=0;
void delay(unsigned int i);
void tx0(unsigned char);
void SMSString(unsigned char*text) ;
void init();
void clear_mybuff();
unsigned char idata MyBuff[bufferSize];
void process_sms(); 

void init()
{
	P1=0xFF;
	P2=0x00;
	TL1=0XFD; //9600 @ 11.0592
	TH1=0xFD;
	TMOD=0x20;
	SCON=0x50;
	TR1=1;
}


void main ()
{

delay(100);  //allow things to settle
init();

SMSString("AT\r"); // AT commands to initialize gsm modem
delay(50);
SMSString( "ATe0\r"); // turn off echo
delay(50);
SMSString( "AT+CMGF=1\r"); // select text mode for sms
delay(50);
SMSString( "AT+CNMI=2,1,0,0,0\r"); //ask for notification of new sms
delay(50);
	
IE=0x90;	//enable serial and global interrupt
receivingMessage=0;   
	
while(1)   //continuous loop
{
	
if(receivingMessage) //if receiving a message ...
{
	
	delay(100); //assume a notification and delay long enough to get it
	receivingMessage=0;   
	SMSString("AT+CMGR=1\r"); //ask for first and only SMS 
	delay(100); //delay long enough to get it
	process_sms();  //process it
	SMSString("AT+CMGD=1,4\r"); //delete all
	delay(2000); //long delay...can take a while
	clear_mybuff();
	receivingMessage=0;  //ready for next
	
}
} //while
} //main



void process_sms()  
{
unsigned char a;
		//convert message to upper case
	for(a=0;a<bufferend;a++)
	MyBuff[a]=toupper(MyBuff[a]);
	
	//we have a message in MyBuff..
	//check it came from me
	if(strstr(MyBuff,"9603658488")==NULL)  //look for my phone number
	{
		badnumber=1;  //error LED to indicate what is wrong
		return;                        //exit if wrong number 
	}
		badnumber=0;  


	if(strstr(MyBuff,"ON A"))  //look for command in the text
	  ldr=1;
	if(strstr(MyBuff,"ON B"))  
	  um=1;
	if(strstr(MyBuff,"ON C"))  
	  tm=1;
}




void SMSString(unsigned char* text) //function to send SMS using GSM modem
{
	while (*text)
	{
		tx0(*text++);
	}
}
void tx0(unsigned char x) //send data to serial port 0
{
	EA=0;
	SBUF=x;
	while(TI==0);
	TI=0;
	EA=1;
}



void serial () interrupt 4
{
	    RI = 0; //clear flag
			if(receivingMessage < bufferend)
			MyBuff[receivingMessage++] = SBUF; //store char
			
			MyBuff[receivingMessage]=0;  //terminate the string
}





void clear_mybuff()
{
	unsigned char a;
	for(a=0;a<bufferend;a++)
	MyBuff[a]=0x00;
}

void delay(unsigned int i)
{
        unsigned int k, l;
        for(k=0;k<i;k++)
                for(l=0;l<1000;l++);
}




